diff -bruN freeswan-1.9.orig/pluto/dir2hash.c freeswan-1.9/pluto/dir2hash.c
--- freeswan-1.9.orig/pluto/dir2hash.c	Wed Dec 31 19:00:00 1969
+++ freeswan-1.9/pluto/dir2hash.c	Wed May 16 10:57:20 2001
@@ -0,0 +1,1071 @@
+/*
+ * Convert an XMAP hash directory to a Berkeley DB hash file
+ */
+
+#include <stdio.h>
+#include <stdlib.h>
+#include <unistd.h>
+#include <sys/types.h>
+#include <sys/stat.h>
+#include <fcntl.h>
+#include <getopt.h>
+#include <string.h>
+#include <dirent.h>
+#include <errno.h>
+#include <netinet/in.h>
+#include <ctype.h>
+
+#ifdef HAVE_DB185
+#include <db_185.h>
+#else
+#include <db.h>
+#endif
+
+#include <openssl/pem.h>
+#include <openssl/bio.h>
+#include <openssl/sha.h>
+#include <openssl/x509.h>
+#include <openssl/x509v3.h>
+
+#define VERSION_SIZE 4
+static unsigned char version_data[] = { '\00', '\00', '\00', '\01' };
+
+#define TAGLEN 4
+
+#define UID_PREFIX "uid-"
+
+#define X509_TYPE 0
+#define X509_CRL_TYPE 1
+
+typedef struct _cert_st {
+  u_int8_t type;
+  union _inf {
+    X509 *x;
+    X509_CRL *c;
+  } info;
+  unsigned char *d;
+  size_t dlen;
+  unsigned char digest[SHA_DIGEST_LENGTH];
+  struct _cert_st *next;
+} CERT;
+
+typedef struct _xname_list_st {
+  unsigned char digest[SHA_DIGEST_LENGTH];
+  struct _xname_list_st *next;
+} XNAME_LIST;
+
+typedef struct _xname_st {
+  unsigned char *d;
+  size_t dlen;
+  int lcount;
+  XNAME_LIST *list;
+  struct _xname_st *next;
+} XNAME;
+
+static const char *hashout = "certhash.db";
+
+void *nalloc( size_t s );
+void dump( unsigned char *p, size_t l, const char *name );
+void free_xname_list_node( XNAME_LIST *node );
+void free_xname_node( XNAME *node );
+void free_xnames( XNAME **nl );
+XNAME *alloc_xname_node( const unsigned char *n, const size_t s );
+int add_unique_xname( XNAME **nl, X509_NAME *name,
+		      const unsigned char *digest );
+int add_unique_xname( XNAME **nl, X509_NAME *name,
+		      const unsigned char *digest );
+void add_unique_dns(XNAME **nl, X509 *x, const unsigned char *digest );
+void add_unique_ip(XNAME **nl, X509 *x, const unsigned char *digest );
+int isCA( X509 *x );
+void free_cert_node( CERT *c );
+int add_unique_xinf( CERT **cl, XNAME **xl,
+		     XNAME **cal, XNAME **dnl, XNAME **ipl,
+		     unsigned int type, void *x );
+void putcerts(DB *db, int start, int end, char *argv[],
+	      CERT **cl, XNAME **xl, XNAME **cal, XNAME **dnl, XNAME **ipl);
+void free_cert_list( CERT **cl );
+void putcrls(DB *db, int start, int end, char *argv[], CERT **cl, XNAME **xl);
+int add_unique_uid(XNAME **ul, X509 *x, const char *uid);
+void putuids(DB *db, int start, int end, char *argv[], XNAME **ul);
+
+void *
+nalloc( size_t s )
+{
+  void *t = malloc(s);
+
+  if (!t) {
+    fprintf(stderr, "cannot allocate %d bytes\n", s);
+    exit(-1);
+  }
+  return t;
+}
+
+void
+dump( unsigned char *p, size_t l, const char *name )
+{
+  int i;
+
+  printf("%s: (length %d)\n", name, l);
+  for(i=0; i<l; i++) {
+    printf("%02X", p[i]);
+    if (i < l-1) putchar((i % 16 == 15) ? '\n' : ':');
+  }
+  printf("\n");
+}
+
+void
+free_xname_list_node( XNAME_LIST *node )
+{
+  free(node);
+}
+
+void
+free_xname_node( XNAME *node )
+{
+  XNAME_LIST *xl, *p;
+
+  if (node->d) free(node->d);
+  for(xl=node->list; xl;) {
+    p = xl->next;
+    free_xname_list_node(xl);
+    xl = p;
+  }
+  free(node);
+}
+
+void
+free_xnames( XNAME **nl )
+{
+  XNAME *l, *p;
+
+  if (!nl) return;
+  for(l = *nl; l; ) {
+    p = l->next;
+    free_xname_node(l);
+    l = p;
+  }
+  *nl = NULL;
+}
+
+XNAME *
+alloc_xname_node( const unsigned char *n, const size_t s )
+{
+  /* Create an empty list for name store in n */
+  XNAME *ret;
+
+  ret = nalloc(sizeof(XNAME));
+  ret->lcount = 0;
+  ret->list = NULL;
+  ret->dlen = s;
+  ret->d = nalloc(s);
+  memcpy(ret->d, n, s);
+  ret->next = NULL;
+
+  return ret;
+}
+
+int
+add_unique_xname( XNAME **nl, X509_NAME *name,
+		  const unsigned char *digest )
+{
+  unsigned char *d, *dum;
+  size_t dlen;
+  XNAME *p;
+  int found, res = 1;
+
+  /* Create DER form of name */
+
+  if (name == NULL) {
+    dlen = 1;
+    d = nalloc(dlen);
+    d[0] = '\0';
+  } else {
+    dlen = i2d_X509_NAME(name, NULL);
+    d = nalloc(dlen); dum = d;
+    i2d_X509_NAME(name, &dum);
+  }
+
+  /* Search nl for name */
+  for (p=*nl, found = 0; ((!found) && (p));
+       (!found) ? p=p->next : p)
+    if ((dlen == p->dlen) && (memcmp(d, p->d, dlen) == 0)) found = 1;
+
+  if (found) {
+    XNAME_LIST *pp;
+
+    /* add digest to list of names if not already there */
+    for(pp = p->list, found = 0; ((!found) && (pp));
+	(!found) ? pp=pp->next : pp)
+      if (memcmp(pp->digest, digest, SHA_DIGEST_LENGTH) == 0) found = 1;
+    
+    if (!found) {
+      XNAME_LIST *n = nalloc(sizeof(XNAME_LIST));
+      n->next = p->list;
+      memcpy(n->digest, digest, SHA_DIGEST_LENGTH);
+      p->list = n;
+      p->lcount++;
+    } else
+      res = 0;
+  } else {
+    p = alloc_xname_node(d, dlen);
+    p->list = nalloc(sizeof(XNAME_LIST));
+    p->list->next = NULL;
+    memcpy(p->list->digest, digest, SHA_DIGEST_LENGTH);
+    p->lcount = 1;
+    p->next = *nl;
+    *nl = p;
+  }
+  free(d);
+  return res;
+}
+
+void
+add_unique_dns(XNAME **nl, X509 *x, const unsigned char *digest )
+{
+  unsigned char *d;
+  size_t dlen;
+  XNAME *p;
+  int found, res = 1;
+  int i, loc;
+  u_char *pp;
+  STACK_OF(GENERAL_NAME) *nsk = NULL;
+  X509_EXTENSION *ext;
+  GENERAL_NAME *gn;
+
+  if ((loc = X509_get_ext_by_NID(x, NID_subject_alt_name, -1)) < 0) return;
+  if ((ext = X509_get_ext(x, loc)) == NULL) return;
+  pp = ext->value->data;
+  d2i_GENERAL_NAMES(&nsk, &pp, ext->value->length);
+  if (!nsk) return;
+  for(i=0; i<sk_GENERAL_NAME_num(nsk); i++) {
+    gn = sk_GENERAL_NAME_value(nsk, i);
+
+    if (gn->type == GEN_DNS) {
+      dlen = gn->d.ia5->length;
+      d = nalloc(dlen);
+      memcpy(d, gn->d.ia5->data, dlen);
+
+      for (p=*nl, found = 0; ((!found) && (p));
+	   (!found) ? p=p->next : p)
+	if ((dlen == p->dlen) && (memcmp(d, p->d, dlen) == 0)) found = 1;
+
+      if (found) {
+	XNAME_LIST *pp;
+	
+	/* add digest to list of names if not already there */
+	for(pp = p->list, found = 0; ((!found) && (pp));
+	    (!found) ? pp=pp->next : pp)
+	  if (memcmp(pp->digest, digest, SHA_DIGEST_LENGTH) == 0) found = 1;
+	
+	if (!found) {
+	  XNAME_LIST *n = nalloc(sizeof(XNAME_LIST));
+	  n->next = p->list;
+	  memcpy(n->digest, digest, SHA_DIGEST_LENGTH);
+	  p->list = n;
+	  p->lcount++;
+	} else
+	  res = 0;
+      } else {
+	p = alloc_xname_node(d, dlen);
+	p->list = nalloc(sizeof(XNAME_LIST));
+	p->list->next = NULL;
+	memcpy(p->list->digest, digest, SHA_DIGEST_LENGTH);
+	p->lcount = 1;
+	p->next = *nl;
+	*nl = p;
+      }
+      free(d);
+    }
+  }
+  sk_GENERAL_NAME_free(nsk);
+}
+
+void
+add_unique_ip(XNAME **nl, X509 *x, const unsigned char *digest )
+{
+  unsigned char *d;
+  size_t dlen;
+  XNAME *p;
+  int found, res = 1;
+  int i, loc;
+  u_char *pp;
+  STACK_OF(GENERAL_NAME) *nsk = NULL;
+  X509_EXTENSION *ext;
+  GENERAL_NAME *gn;
+
+  if ((loc = X509_get_ext_by_NID(x, NID_subject_alt_name, -1)) < 0) return;
+  if ((ext = X509_get_ext(x, loc)) == NULL) return;
+  pp = ext->value->data;
+  d2i_GENERAL_NAMES(&nsk, &pp, ext->value->length);
+  if (!nsk) return;
+  for(i=0; i<sk_GENERAL_NAME_num(nsk); i++) {
+    gn = sk_GENERAL_NAME_value(nsk, i);
+
+    if (gn->type == GEN_IPADD) {
+      dlen = gn->d.ip->length;
+      d = nalloc(dlen);
+      memcpy(d, gn->d.ip->data, dlen);
+
+      for (p=*nl, found = 0; ((!found) && (p));
+	   (!found) ? p=p->next : p)
+	if ((dlen == p->dlen) && (memcmp(d, p->d, dlen) == 0)) found = 1;
+
+      if (found) {
+	XNAME_LIST *pp;
+	
+	/* add digest to list of names if not already there */
+	for(pp = p->list, found = 0; ((!found) && (pp));
+	    (!found) ? pp=pp->next : pp)
+	  if (memcmp(pp->digest, digest, SHA_DIGEST_LENGTH) == 0) found = 1;
+	
+	if (!found) {
+	  XNAME_LIST *n = nalloc(sizeof(XNAME_LIST));
+	  n->next = p->list;
+	  memcpy(n->digest, digest, SHA_DIGEST_LENGTH);
+	  p->list = n;
+	  p->lcount++;
+	} else
+	  res = 0;
+      } else {
+	p = alloc_xname_node(d, dlen);
+	p->list = nalloc(sizeof(XNAME_LIST));
+	p->list->next = NULL;
+	memcpy(p->list->digest, digest, SHA_DIGEST_LENGTH);
+	p->lcount = 1;
+	p->next = *nl;
+	*nl = p;
+      }
+      free(d);
+    }
+  }
+  sk_GENERAL_NAME_free(nsk);
+}
+
+int
+isCA( X509 *x )
+{
+  X509_EXTENSION *ext;
+  BASIC_CONSTRAINTS *p = NULL;
+  int loc;
+  
+  loc = X509_get_ext_by_NID(x, NID_basic_constraints, -1);
+  if (loc >= 0) {
+    ext = X509_get_ext(x, loc);
+    if (ext) {
+      p = X509V3_EXT_d2i(ext);
+      if (! p->ca) {
+	BASIC_CONSTRAINTS_free(p);
+	return 0;
+      } else {
+	BASIC_CONSTRAINTS_free(p);
+	return 1; /* This is a CA certificate */
+      }
+    } else
+      return 0;
+  } else
+    return 0;
+}
+
+void
+free_cert_node( CERT *c )
+{
+  if (c->d) free(c->d);
+  c->d = NULL;
+  switch(c->type) {
+    case X509_TYPE: if (c->info.x) X509_free(c->info.x); break;
+    case X509_CRL_TYPE: if (c->info.c) X509_CRL_free(c->info.c); break;
+  }
+  c->info.x = NULL;
+  memset(c->digest, 0, SHA_DIGEST_LENGTH);
+  c->next = NULL;
+  free(c);
+}
+
+int
+add_unique_xinf( CERT **cl, XNAME **xl,
+		 XNAME **cal, XNAME **dnl, XNAME **ipl,
+		 unsigned int type, void *x )
+{
+  int f;
+  CERT *p, *node;
+  unsigned char *dum;
+
+  if (!cl) return 0;
+
+  node = nalloc(sizeof(CERT));
+  node->next = NULL;
+  node->type = type;
+  switch(type) {
+  case X509_TYPE:
+    node->info.x = (X509 *)x;
+    node->dlen = i2d_X509((X509 *)x, NULL);
+    node->d = nalloc(node->dlen);
+    dum = node->d;
+    i2d_X509( (X509 *)x, &dum );
+    break;
+  case X509_CRL_TYPE:
+    node->info.c = (X509_CRL *)x;
+    node->dlen = i2d_X509_CRL((X509_CRL *)x, NULL);
+    node->d = nalloc(node->dlen);
+    dum = node->d;
+    i2d_X509_CRL( (X509_CRL *)x, &dum );
+    break;
+  default:
+    fprintf(stderr, "Unknown info type: %d\n", type);
+    free(node);
+    return 0;
+  }
+
+  SHA1(node->d, node->dlen, node->digest);
+
+  for(p=*cl, f=0; (!f) && (p); p=p->next)
+    if (memcmp(p->digest, node->digest, SHA_DIGEST_LENGTH) == 0) f=1;
+    /* found a duplicate */
+
+  if (!f) {
+    /* insert at head of list */
+    node->next = *cl;
+    *cl = node;
+    switch(type) {
+    case X509_TYPE:
+      add_unique_xname(xl, X509_get_subject_name((X509 *)x), node->digest);
+      if (isCA(x)) add_unique_xname(cal, NULL, node->digest);
+      add_unique_dns(dnl, (X509 *)x, node->digest);
+      add_unique_ip(ipl, (X509 *)x, node->digest);
+      break;
+    case X509_CRL_TYPE:
+      add_unique_xname(xl, X509_CRL_get_issuer((X509_CRL *)x), node->digest);
+      break;
+    }
+    return 1;
+  } else
+    return 0;
+}
+
+void
+free_cert_list( CERT **cl )
+{
+  CERT *c;
+
+  if (!cl) return;
+
+  for(c=*cl; c;) {
+    CERT *p = c->next;
+
+    free_cert_node(c);
+    c = p;
+  }
+  *cl = NULL;
+}
+
+static char dirname[PATH_MAX+1];
+static int
+select_files(const struct dirent *de)
+{
+  struct stat st;
+  char path[PATH_MAX+1];
+
+  snprintf(path, sizeof(path), "%s/%s", dirname, de->d_name);
+  if (lstat(path, &st) == 0) {
+    if (S_ISREG(st.st_mode))
+      return 1;
+    else
+      return 0;
+  } else {
+    perror("stat");
+    return 0;
+  }
+}
+
+static int
+select_uid_files(const struct dirent *de)
+{
+  struct stat st;
+  char path[PATH_MAX+1];
+
+  if (strncasecmp(UID_PREFIX, de->d_name, strlen(UID_PREFIX)) != 0) return 0;
+  snprintf(path, sizeof(path), "%s/%s", dirname, de->d_name);
+  if (lstat(path, &st) == 0) {
+    if ((S_ISREG(st.st_mode)) || (S_ISLNK(st.st_mode)))
+      return 1;
+    else
+      return 0;
+  } else {
+    perror("stat");
+    return 0;
+  }
+}
+
+void
+putcerts(DB *db, int start, int end, char *argv[],
+	 CERT **cl, XNAME **xl, XNAME **cal, XNAME **dnl, XNAME **ipl)
+{
+  int i, j, n;
+  struct dirent **namelist = NULL;
+  char path[PATH_MAX+1];
+
+  for(i=start; i<end; i++) {
+    printf("Dumping certs from directory \"%s\"\n", argv[i]);
+    snprintf(dirname, sizeof(dirname)-1, "%s", argv[i]);
+    if ((n = scandir(argv[i], &namelist, select_files, alphasort)) >= 0) {
+      for(j=0; j<n; j++) {
+	BIO *b;
+
+	printf("File: %s\n", namelist[j]->d_name);
+	snprintf(path, sizeof(path), "%s/%s", argv[i], namelist[j]->d_name);
+	if ((b = BIO_new_file(path, "r")) != NULL) {
+	  X509 *x;
+
+	  if (!(x = PEM_read_bio_X509(b, NULL, NULL, NULL))) {
+	    BIO_ctrl(b, BIO_CTRL_RESET, 0, NULL);
+	    x = d2i_X509_bio(b, NULL);
+	  }
+	  if ((x) && (!add_unique_xinf(cl, xl, cal, dnl, ipl, X509_TYPE, x)))
+	    X509_free(x);
+	  BIO_free(b);
+	}
+      }
+      free(namelist);
+    } else
+      perror("scandir");
+  }
+}
+
+void
+putcrls(DB *db, int start, int end, char *argv[], CERT **cl, XNAME **xl)
+{
+  int i, j, n;
+  struct dirent **namelist = NULL;
+  char path[PATH_MAX+1];
+
+  for(i=start; i<end; i++) {
+    printf("Dumping CRLs from directory \"%s\"\n", argv[i]);
+    snprintf(dirname, sizeof(dirname)-1, "%s", argv[i]);
+    if ((n = scandir(argv[i], &namelist, select_files, alphasort)) >= 0) {
+      for(j=0; j<n; j++) {
+	BIO *b;
+
+	printf("File: %s\n", namelist[j]->d_name);
+	snprintf(path, sizeof(path), "%s/%s", argv[i], namelist[j]->d_name);
+	if ((b = BIO_new_file(path, "r")) != NULL) {
+	  X509_CRL *c;
+
+	  if (!(c = PEM_read_bio_X509_CRL(b, NULL, NULL, NULL))) {
+	    BIO_ctrl(b, BIO_CTRL_RESET, 0, NULL);
+	    c = d2i_X509_CRL_bio(b, NULL);
+	  }
+	  if ((c) &&
+	      (!add_unique_xinf(cl, xl, NULL, NULL, NULL,X509_CRL_TYPE, c)))
+	    X509_CRL_free(c);
+
+	  BIO_free(b);
+	}
+      }
+      free(namelist);
+    } else
+      perror("scandir");
+  }
+}
+
+int
+add_unique_uid(XNAME **ul, X509 *x, const char *uid)
+{
+  int found;
+  XNAME *p;
+  unsigned char digest[SHA_DIGEST_LENGTH], *d, *dum;
+  size_t dlen;
+
+  if (!x || !ul) return 0;
+
+  dlen = i2d_X509(x, NULL);
+  d = nalloc(dlen);
+  dum = d;
+  i2d_X509( x, &dum );
+
+  SHA1(d, dlen, digest);
+  free(d);
+
+  printf("Adding user id \"%s\"\n", uid);
+  for(found=0, p=*ul; ((!found) && (p)); 
+      (!found) ? p=p->next : p)
+    if ((strlen(uid) == p->dlen) && (memcmp(p->d, uid, p->dlen) == 0))
+      found = 1;
+
+  if (found) {
+    XNAME_LIST *pp;
+    
+    for(pp = p->list, found = 0; ((!found) && (pp));
+	pp=(!found) ? pp->next : pp)
+      if (memcmp(pp->digest, digest, SHA_DIGEST_LENGTH) == 0) found = 1;
+    
+    if (!found) {
+      XNAME_LIST *n = nalloc(sizeof(XNAME_LIST));
+      n->next = p->list;
+      memcpy(n->digest, digest, SHA_DIGEST_LENGTH);
+      p->list = n;
+      p->lcount++;
+    } else
+      return 0;
+  } else {
+    p = alloc_xname_node(uid, strlen(uid));
+    p->list = nalloc(sizeof(XNAME_LIST));
+    p->list->next = NULL;
+    memcpy(p->list->digest, digest, SHA_DIGEST_LENGTH);
+    p->lcount = 1;
+    p->next = *ul;
+    *ul = p;
+    return 1;
+  }
+  return 0;
+}
+
+static int
+isuidchar( char c )
+{
+  if (isalnum(c)) return 1;
+  if (c == '_') return 1;
+  return 0;
+}
+
+void
+putuids(DB *db, int start, int end, char *argv[], XNAME **ul)
+{
+  int i, j, n;
+  struct dirent **namelist = NULL;
+  char path[PATH_MAX+1];
+
+  for(i=start; i<end; i++) {
+    printf("Dumping uids from directory \"%s\"\n", argv[i]);
+    snprintf(dirname, sizeof(dirname)-1, "%s", argv[i]);
+    if ((n = scandir(argv[i], &namelist, select_uid_files, alphasort)) >= 0) {
+      for(j=0; j<n; j++) {
+	BIO *b;
+	char *n, *nn;
+
+	printf("File: %s\n", namelist[j]->d_name);
+	snprintf(path, sizeof(path), "%s/%s", argv[i], namelist[j]->d_name);
+	if ((b = BIO_new_file(path, "r")) != NULL) {
+	  X509 *x;
+
+	  if (!(x = PEM_read_bio_X509(b, NULL, NULL, NULL))) {
+	    BIO_ctrl(b, BIO_CTRL_RESET, 0, NULL);
+	    x = d2i_X509_bio(b, NULL);
+	  }
+
+	  n = nn = strdup(&(namelist[j]->d_name[strlen(UID_PREFIX)]));
+	  while ((*nn) && (isuidchar(*nn))) nn++;
+	  *nn = '\0';
+	  if ((x) && (!add_unique_uid(ul, x, n))) X509_free(x);
+
+	  BIO_free(b);
+	}
+      }
+      free(namelist);
+    } else
+      perror("scandir");
+  }
+}
+
+int
+main( int argc, char *argv[] )
+{
+  int c;
+  DB *db;
+  CERT *clist = NULL, *crlist = NULL;
+  XNAME *xlist = NULL, *nlist = NULL, *xcrlist = NULL, *calist = NULL;
+  XNAME *dnlist = NULL, *iplist = NULL;
+
+  while(1) {
+    int option_index = 0;
+    static struct option long_options[] = {
+      { "output", 1, 0, 0 },
+      { 0, 0, 0, 0 }
+    };
+
+    c = getopt_long(argc, argv, "o:",
+		    long_options, &option_index);
+    if (c == -1) break;
+
+    switch(c) {
+    case 0:
+      if (strcasecmp(long_options[option_index].name, "output") == 0)
+	hashout = optarg;
+      break;
+    case 'o':
+      hashout = optarg;
+      break;
+    case '?':
+      break;
+    default:
+      printf("?? getopt returned character code 0%o ??\n", c);
+    }
+  }
+
+  X509V3_add_standard_extensions();
+
+  if ((db = dbopen(hashout, O_CREAT | O_TRUNC | O_RDWR, 0644, DB_HASH, NULL)) == NULL) {
+    perror("dbopen");
+  } else {
+    DBT k, v;
+    CERT *c;
+    XNAME *x;
+    unsigned char *kk, *vv;
+
+    memset(&k, 0, sizeof(DBT));
+    memset(&v, 0, sizeof(DBT));
+    k.data = strdup("\xFF\xFF\xFF\xFFversion");
+    k.size = strlen("version") + TAGLEN;
+    v.data = version_data;
+    v.size = VERSION_SIZE;
+
+    if (db->put(db, &k, &v, 0) != 0) perror("dbput");
+    db->sync(db, 0);
+    free(k.data);
+
+    putcerts(db, optind, argc, argv,
+	     &clist, &xlist,
+	     &calist, &dnlist, &iplist);
+    putcrls(db, optind, argc, argv, &crlist, &xcrlist);
+    putuids(db, optind, argc, argv, &nlist);
+
+    for(c=clist; c; c=c->next) {
+      k.size = SHA_DIGEST_LENGTH+TAGLEN;
+      k.data = nalloc(k.size);
+      v.size = c->dlen;
+      v.data = nalloc(v.size);
+
+      kk = k.data;
+      vv = v.data;
+      memset(kk, 0, TAGLEN);
+      memcpy(&kk[TAGLEN], c->digest, SHA_DIGEST_LENGTH);
+      memcpy(vv, c->d, c->dlen);
+
+      if (db->put(db, &k, &v, 0) != 0) perror("dbput");
+      free(k.data);
+      free(v.data);
+    }
+    free_cert_list(&clist);
+
+    for(x=xlist; x; x=x->next) {
+      u_int32_t cnt;
+      int i;
+      XNAME_LIST *p;
+
+      k.size = x->dlen + TAGLEN;
+      k.data = nalloc(k.size);
+      v.size = TAGLEN + x->lcount * SHA_DIGEST_LENGTH;
+      v.data = nalloc(v.size);
+      kk = k.data;
+      vv = v.data;
+
+      memset(kk, 0, TAGLEN-1); kk[TAGLEN-1] = '\01';
+      memcpy(&kk[TAGLEN], x->d, x->dlen);
+      cnt = htonl(x->lcount);
+      memcpy(vv, (unsigned char *)&cnt, TAGLEN);
+      for(i=0, p=x->list; i<x->lcount; i++, p=p->next)
+	memcpy(&vv[TAGLEN + i*SHA_DIGEST_LENGTH],
+	       p->digest, SHA_DIGEST_LENGTH);
+      if (db->put(db, &k, &v, 0) < 0) perror("dbput");
+      free(k.data);
+      free(v.data);
+    }
+    free_xnames(&xlist);
+
+    for(x=calist; x; x=x->next) {
+      u_int32_t cnt;
+      int i;
+      XNAME_LIST *p;
+
+      k.size = TAGLEN;
+      k.data = nalloc(k.size);
+      v.size = TAGLEN + x->lcount * SHA_DIGEST_LENGTH;
+      v.data = nalloc(v.size);
+      kk = k.data;
+      vv = v.data;
+
+      memset(kk, 0, TAGLEN-1); kk[TAGLEN-1] = '\05';
+      cnt = htonl(x->lcount);
+      memcpy(vv, (unsigned char *)&cnt, TAGLEN);
+      for(i=0, p=x->list; i<x->lcount; i++, p=p->next)
+	memcpy(&vv[TAGLEN + i*SHA_DIGEST_LENGTH],
+	       p->digest, SHA_DIGEST_LENGTH);
+      if (db->put(db, &k, &v, 0) != 0) perror("dbput");
+      free(k.data);
+      free(v.data);
+    }
+    free_xnames(&calist);
+
+    for(x=dnlist; x; x=x->next) {
+      u_int32_t cnt;
+      int i;
+      XNAME_LIST *p;
+
+      k.size = x->dlen + TAGLEN;
+      k.data = nalloc(k.size);
+      v.size = TAGLEN + x->lcount * SHA_DIGEST_LENGTH;
+      v.data = nalloc(v.size);
+      kk = k.data;
+      vv = v.data;
+
+      memset(kk, 0, TAGLEN-1); kk[TAGLEN-1] = '\06';
+      memcpy(&kk[TAGLEN], x->d, x->dlen);
+      cnt = htonl(x->lcount);
+      memcpy(vv, (unsigned char *)&cnt, TAGLEN);
+      for(i=0, p=x->list; i<x->lcount; i++, p=p->next)
+	memcpy(&vv[TAGLEN + i*SHA_DIGEST_LENGTH],
+	       p->digest, SHA_DIGEST_LENGTH);
+      if (db->put(db, &k, &v, 0) != 0) perror("dbput");
+      free(k.data);
+      free(v.data);
+    }
+    free_xnames(&dnlist);
+
+    for(x=iplist; x; x=x->next) {
+      u_int32_t cnt;
+      int i;
+      XNAME_LIST *p;
+
+      k.size = x->dlen + TAGLEN;
+      k.data = nalloc(k.size);
+      v.size = TAGLEN + x->lcount * SHA_DIGEST_LENGTH;
+      v.data = nalloc(v.size);
+      kk = k.data;
+      vv = v.data;
+
+      memset(kk, 0, TAGLEN-1); kk[TAGLEN-1] = '\07';
+      memcpy(&kk[TAGLEN], x->d, x->dlen);
+      cnt = htonl(x->lcount);
+      memcpy(vv, (unsigned char *)&cnt, TAGLEN);
+      for(i=0, p=x->list; i<x->lcount; i++, p=p->next)
+	memcpy(&vv[TAGLEN + i*SHA_DIGEST_LENGTH],
+	       p->digest, SHA_DIGEST_LENGTH);
+      if (db->put(db, &k, &v, 0) != 0) perror("dbput");
+      free(k.data);
+      free(v.data);
+    }
+    free_xnames(&iplist);
+
+    for(c=crlist; c; c=c->next) {
+      k.size = SHA_DIGEST_LENGTH+TAGLEN;
+      k.data = nalloc(k.size);
+      v.size = c->dlen;
+      v.data = nalloc(v.size);
+
+      kk = k.data;
+      vv = v.data;
+      memset(kk, 0, TAGLEN-1); kk[TAGLEN-1] = '\04';
+      memcpy(&kk[TAGLEN], c->digest, SHA_DIGEST_LENGTH);
+      memcpy(vv, c->d, c->dlen);
+
+      if (db->put(db, &k, &v, 0) != 0) perror("dbput");
+      free(k.data);
+      free(v.data);
+    }
+    free_cert_list(&crlist);
+
+    for(x=xcrlist; x; x=x->next) {
+      u_int32_t cnt;
+      int i;
+      XNAME_LIST *p;
+
+      k.size = x->dlen + TAGLEN;
+      k.data = nalloc(k.size);
+      v.size = TAGLEN + x->lcount * SHA_DIGEST_LENGTH;
+      v.data = nalloc(v.size);
+      kk = k.data;
+      vv = v.data;
+
+      memset(kk, 0, TAGLEN-1); kk[TAGLEN-1] = '\02';
+      memcpy(&kk[TAGLEN], x->d, x->dlen);
+      cnt = htonl(x->lcount);
+      memcpy(vv, (unsigned char *)&cnt, TAGLEN);
+      for(i=0, p=x->list; i<x->lcount; i++, p=p->next)
+	memcpy(&vv[TAGLEN + i*SHA_DIGEST_LENGTH],
+	       p->digest, SHA_DIGEST_LENGTH);
+      if (db->put(db, &k, &v, 0) != 0) perror("dbput");
+      free(k.data);
+      free(v.data);
+    }
+    free_xnames(&xcrlist);
+
+    for(x=nlist; x; x=x->next) {
+      u_int32_t cnt;
+      int i;
+      XNAME_LIST *p;
+
+      k.size = x->dlen + TAGLEN;
+      k.data = nalloc(k.size);
+      v.size = TAGLEN + x->lcount * SHA_DIGEST_LENGTH;
+      v.data = nalloc(v.size);
+      kk = k.data;
+      vv = v.data;
+
+      memset(kk, 0, TAGLEN-1); kk[TAGLEN-1] = '\03';
+      memcpy(&kk[TAGLEN], x->d, x->dlen);
+      cnt = htonl(x->lcount);
+      memcpy(vv, (unsigned char *)&cnt, TAGLEN);
+      for(i=0, p=x->list; i<x->lcount; i++, p=p->next)
+	memcpy(&vv[TAGLEN + i*SHA_DIGEST_LENGTH],
+	       p->digest, SHA_DIGEST_LENGTH);
+      if (db->put(db, &k, &v, 0) != 0) perror("dbput");
+      free(k.data);
+      free(v.data);
+    }
+    free_xnames(&nlist);
+    db->close(db);
+  }
+
+  printf("Dumping keys from DB file\n");
+  if ((db = dbopen(hashout, 0, 0, DB_HASH, NULL)) == NULL) {
+    perror("db_open");
+  } else {
+    DBT k, v;
+    int i;
+
+    memset(&k, 0, sizeof(k));
+    memset(&v, 0, sizeof(v));
+    while (db->seq(db, &k, &v, R_NEXT) == 0) {
+      if (k.size < TAGLEN)
+	fprintf(stderr, "Error: key value too short\n");
+      else {
+	unsigned char *kk = k.data, *vv = v.data, *p;
+	u_int32_t c1, c2;
+	X509_NAME *xn;
+	
+	switch(kk[TAGLEN-1]) {
+	case 0:
+	  printf("X509 Certificate\n");
+	  dump(&kk[TAGLEN], k.size-TAGLEN, "SHA-DIGEST");
+	  printf("Data Length %d\n", v.size);
+	  break;
+	case 1:
+	  printf("X509 Subject Name\n");
+	  p = &kk[TAGLEN];
+	  if ((xn = d2i_X509_NAME(NULL, &p, k.size-TAGLEN)) != NULL) {
+	    char buf[256];
+	    
+	    X509_NAME_oneline(xn, buf, sizeof(buf));
+	    printf("%s:\n", buf);
+	    X509_NAME_free(xn);
+	    memcpy((unsigned char *)(&c1), v.data, TAGLEN);
+	    c2 = ntohl(c1);
+	    if (v.size != TAGLEN + (SHA_DIGEST_LENGTH * c2)) {
+	      fprintf(stderr, "X509 name length error\n");
+	    } else {
+	      for(i=0; i<c2; i++)
+		dump( &vv[TAGLEN + i*SHA_DIGEST_LENGTH],
+		      SHA_DIGEST_LENGTH, "SHA-DIGEST");
+	    }
+	    printf("\n");
+	  }
+	  break;
+	case 0x02:
+	  printf("X509 CRL Issuer Name\n");
+	  p = &kk[TAGLEN];
+	  if ((xn = d2i_X509_NAME(NULL, &p, k.size-TAGLEN)) != NULL) {
+	    char buf[256];
+	    
+	    X509_NAME_oneline(xn, buf, sizeof(buf));
+	    printf("%s:\n", buf);
+	    X509_NAME_free(xn);
+	    memcpy((unsigned char *)(&c1), v.data, TAGLEN);
+	    c2 = ntohl(c1);
+	    if (v.size != TAGLEN + (SHA_DIGEST_LENGTH * c2)) {
+	      fprintf(stderr, "X509 name length error\n");
+	    } else {
+	      for(i=0; i<c2; i++)
+		dump( &vv[TAGLEN + i*SHA_DIGEST_LENGTH],
+		      SHA_DIGEST_LENGTH, "SHA-DIGEST");
+	    }
+	    printf("\n");
+	  }
+	  break;
+	case 0x03:
+	  printf("UID: ");
+	  for(i=TAGLEN; i<k.size; i++)
+	    printf("%c", isprint(kk[i]) ? kk[i] : '?');
+	  printf("\n");
+	  memcpy((unsigned char *)(&c1), v.data, TAGLEN);
+	  c2 = ntohl(c1);
+	  if (v.size != TAGLEN + (SHA_DIGEST_LENGTH * c2)) {
+	    fprintf(stderr, "X509 name length error\n");
+	  } else {
+	    for(i=0; i<c2; i++)
+	      dump( &vv[TAGLEN + i*SHA_DIGEST_LENGTH],
+		    SHA_DIGEST_LENGTH, "SHA-DIGEST");
+	  }
+	  printf("\n");
+	  break;
+	case 0x04:
+	  printf("X509 Certificate Revocation List\n");
+	  dump(&kk[TAGLEN], k.size-TAGLEN, "SHA-DIGEST");
+	  printf("Data Length %d\n", v.size);
+	  break;
+	case 0x05:
+	  printf("CA Certificate:\n");
+	  memcpy((unsigned char *)(&c1), v.data, TAGLEN);
+	  c2 = ntohl(c1);
+	  if (v.size != TAGLEN + (SHA_DIGEST_LENGTH * c2)) {
+	    fprintf(stderr, "X509 name length error\n");
+	  } else {
+	    for(i=0; i<c2; i++)
+	      dump( &vv[TAGLEN + i*SHA_DIGEST_LENGTH],
+		    SHA_DIGEST_LENGTH, "SHA-DIGEST");
+	  }
+	  printf("\n");
+	  break;
+	case 0x06:
+	  printf("DNS: ");
+	  for(i=TAGLEN; i<k.size; i++)
+	    printf("%c", isprint(kk[i]) ? kk[i] : '?');
+	  printf("\n");
+	  memcpy((unsigned char *)(&c1), v.data, TAGLEN);
+	  c2 = ntohl(c1);
+	  if (v.size != TAGLEN + (SHA_DIGEST_LENGTH * c2)) {
+	    fprintf(stderr, "X509 name length error\n");
+	  } else {
+	    for(i=0; i<c2; i++)
+	      dump( &vv[TAGLEN + i*SHA_DIGEST_LENGTH],
+		    SHA_DIGEST_LENGTH, "SHA-DIGEST");
+	  }
+	  printf("\n");
+	  break;
+	case 0x07:
+	  printf("IPv4: ");
+	  for(i=TAGLEN; i<k.size; i++)
+	    printf("%d.", kk[i]);
+	  printf("\n");
+	  memcpy((unsigned char *)(&c1), v.data, TAGLEN);
+	  c2 = ntohl(c1);
+	  if (v.size != TAGLEN + (SHA_DIGEST_LENGTH * c2)) {
+	    fprintf(stderr, "X509 name length error\n");
+	  } else {
+	    for(i=0; i<c2; i++)
+	      dump( &vv[TAGLEN + i*SHA_DIGEST_LENGTH],
+		    SHA_DIGEST_LENGTH, "SHA-DIGEST");
+	  }
+	  printf("\n");
+	  break;
+	case 0xFF:
+	  printf("Metainfo: ");
+	  for(i=TAGLEN; i<k.size; i++)
+	    printf("%c", isprint(kk[i]) ? kk[i] : '?');
+	  printf(":- ");
+	  dump(v.data, v.size, "Value");
+	  printf("\n");
+	  break;
+	default:
+	  fprintf(stderr, "Error in type field: %02X\n", kk[TAGLEN-1]);
+	  break;
+	}
+      }
+    }
+    db->close(db);
+  }
+  printf("Done\n");
+
+  X509V3_EXT_cleanup();
+  return 0;
+}
+
+
